#include "functions.h"
#include "classes.h"
#include "functions-xs-macros.h"
#include "irssi-bits.h"
#include "utils.h"

SF_GEN(irssi_bits2level, "j", XSTR, bits2level(a[0].i))
SF_GEN(irssi_channel_find, "S", IOBJ, channel_find(NULL, a[0].s))
SF_GEN(irssi_query_find, "S", IOBJ, query_find(NULL, a[0].s))
SF_GEN(irssi_chatnet_find, "S", IOBJ, chatnet_find(a[0].s))
SF_GEN(irssi_command, "S", VOID, irssi_script_command(a[0].s, NULL, NULL))
SF_GEN(irssi_combine_level, "jS", INT, combine_level(a[0].i, a[1].s))
SF_GEN(irssi_format_get_length, "S", INT, format_get_length(a[0].s))
SF_GEN(irssi_format_real_length, "Sj", INT, format_real_length(a[0].s, a[1].i))
SF_GEN(irssi_get_gui, "", INT, irssi_gui)
SF_GEN(irssi_get_irssi_binary, "", STR, irssi_binary)
SF_GEN(irssi_get_irssi_config, "", STR, get_irssi_config())
SF_GEN(irssi_get_irssi_dir, "", STR, get_irssi_dir())
SF_GEN(irssi_gui_input_get_pos, "", INT, gui_entry_get_pos(active_entry))
SF_GEN(irssi_gui_input_set, "S", VOID, gui_entry_set_text(active_entry, a[0].s))
SF_GEN(irssi_gui_input_set_pos, "j", VOID, gui_entry_set_pos(active_entry, a[0].i))
SF_GEN(irssi_windows_refnum_last, "", INT, windows_refnum_last())
SF_GEN(irssi_window_refnum_prev, "jb", INT, window_refnum_prev(a[0].i, a[1].b))
SF_GEN(irssi_window_refnum_next, "jb", INT, window_refnum_next(a[0].i, a[1].b))
SF_GEN(irssi_window_item_find, "S", IOBJ, window_item_find(NULL, a[0].s))
SF_GEN(irssi_window_find_refnum, "j", TOBJ(Irssi::UI::Window), window_find_refnum(a[0].i))
SF_GEN(irssi_window_find_name, "S", TOBJ(Irssi::UI::Window), window_find_name(a[0].s))
SF_GEN(irssi_window_find_level, "j", TOBJ(Irssi::UI::Window), window_find_level(NULL, a[0].i))
SF_GEN(irssi_window_find_item, "S", TOBJ(Irssi::UI::Window), window_find_item(NULL, a[0].s))
SF_GEN(irssi_window_find_closest, "Sj", TOBJ(Irssi::UI::Window), window_find_closest(NULL, a[0].s, a[1].i))
SF_GEN(irssi_level2bits, "S", INT, level2bits(a[0].s, NULL))
SF_GEN(irssi_pidwait_add, "j", VOID, pidwait_add(a[0].i))
SF_GEN(irssi_pidwait_remove, "j", VOID, pidwait_remove(a[0].i))
SF_GEN(irssi_strip_codes, "S", XSTR, strip_codes(a[0].s))
SF_GEN(irssi_signal_stop, "", VOID, signal_stop())
SF_GEN(irssi_signal_stop_by_name, "S", VOID, signal_stop_by_name(a[0].s))
SF_GEN(irssi_signal_get_emitted, "", STR, signal_get_emitted())
SF_GEN(irssi_signal_get_emitted_id, "", INT, signal_get_emitted_id())
SF_GEN(irssi_themes_reload, "", VOID, themes_reload())
SF_GEN(irssi_server_find_tag, "S", IOBJ, server_find_tag(a[0].s))
SF_GEN(irssi_server_find_chatnet, "S", IOBJ, server_find_chatnet(a[0].s))
SF_GEN(irssi_log_create_rec, "Sj", TOBJ(Irssi::Log), log_create_rec(a[0].s, a[1].i))
SF_GEN(irssi_log_find, "S", TOBJ(Irssi::Log), log_find(a[0].s))
SF_GEN(irssi_ctcp_register, "S", VOID, ctcp_register(a[0].s))
SF_GEN(irssi_ctcp_unregister, "S", VOID, ctcp_unregister(a[0].s))
SF_GEN(irssi_windows, "", TOBJARR(Irssi::UI::Window), windows)
SF_GEN(irssi_chatnets, "", IOBJARR, chatnets)
SF_GEN(irssi_servers, "", IOBJARR, servers)
SF_GEN(irssi_queries, "", IOBJARR, queries)
SF_GEN(irssi_channels, "", IOBJARR, channels)
SF_GEN(irssi_commands, "", TOBJARR(Irssi::Command), commands)
SF_GEN(irssi_ignores, "", TOBJARR(Irssi::Ignore), ignores)
SF_GEN(irssi_reconnects, "", TOBJARR(Irssi::Reconnect), reconnects)
SF_GEN(irssi_logs, "", TOBJARR(Irssi::Log), logs)
SF_GEN(irssi_settings_get_str, "S", STR, settings_get_str(a[0].s))
SF_GEN(irssi_settings_get_bool, "S", BOOL, settings_get_bool(a[0].s))
SF_GEN(irssi_settings_get_int, "S", INT, settings_get_int(a[0].s))
SF_GEN(irssi_settings_get_time, "S", INT, settings_get_time(a[0].s))
SF_GEN(irssi_settings_get_level, "S", INT, settings_get_level(a[0].s))
SF_GEN(irssi_settings_get_size, "S", INT, settings_get_size(a[0].s))
SF_GEN(irssi_settings_set_str, "SS", VOID, settings_set_str(a[0].s, a[1].s))
SF_GEN(irssi_settings_set_int, "Sj", VOID, settings_set_int(a[0].s, a[1].i))
SF_GEN(irssi_settings_set_bool, "Sb", VOID, settings_set_bool(a[0].s, a[1].b))
SF_GEN(irssi_settings_set_time, "SS", BOOL, settings_set_time(a[0].s, a[1].s))
SF_GEN(irssi_settings_set_level, "SS", BOOL, settings_set_level(a[0].s, a[1].s))
SF_GEN(irssi_settings_set_size, "SS", BOOL, settings_set_size(a[0].s, a[1].s))
SF_GEN(irssi_settings_add_str, "SSS", VOID, script_settings_add_str(a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_settings_add_int, "SSj", VOID, script_settings_add_int(a[0].s, a[1].s, a[2].i))
SF_GEN(irssi_settings_add_bool, "SSb", VOID, script_settings_add_bool(a[0].s, a[1].s, a[2].b))
SF_GEN(irssi_settings_add_time, "SSS", VOID, script_settings_add_time(a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_settings_add_level, "SSS", VOID, script_settings_add_level(a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_settings_add_size, "SSS", VOID, script_settings_add_size(a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_settings_remove, "S", VOID, script_settings_remove(a[0].s))
SF_GEN(irssi_mask_match, "SSSS", BOOL, mask_match(NULL, a[0].s, a[1].s, a[2].s, a[3].s))
SF_GEN(irssi_mask_match_address, "SSS", BOOL, mask_match_address(NULL, a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_masks_match, "SSS", BOOL, masks_match(NULL, a[0].s, a[1].s, a[2].s))
SF_GEN(irssi_ignore_check, "SSSSj", BOOL, ignore_check(NULL, a[0].s, a[1].s, a[2].s, a[3].s, a[4].i))
SF_GEN(irssi_gui_printtext, "jjS", VOID, gui_printtext(a[0].i, a[1].i, a[2].s))
SF_GEN(irssi_rawlog_create, "", TOBJ(Irssi::Rawlog), rawlog_create())
SF_GEN(irssi_rawlog_set_size, "j", VOID, rawlog_set_size(a[0].i))
SF_GEN(irssi_statusbars_recreate_items, "", VOID, statusbars_recreate_items())
SF_GEN(irssi_statusbar_items_redraw, "S", VOID, statusbar_items_redraw(a[0].s))




SV_GEN(irssi_ui_window, set_name, WINDOW_REC, "S", VOID, window_set_name(N, a[0].s))
SV_GEN(irssi_ui_window, destroy, WINDOW_REC, "", VOID, window_destroy(N))
SV_GEN(irssi_ui_window, get_active_name, WINDOW_REC, "", STR, window_get_active_name(N))
SV_GEN(irssi_ui_window, item_next, WINDOW_REC, "", VOID, window_item_next(N))
SV_GEN(irssi_ui_window, item_prev, WINDOW_REC, "", VOID, window_item_prev(N))
SV_GEN(irssi_ui_window, set_active, WINDOW_REC, "", VOID, window_set_active(N))
SV_GEN(irssi_ui_window, set_history, WINDOW_REC, "S", VOID, window_set_history(N, a[0].s))
SV_GEN(irssi_ui_window, set_level, WINDOW_REC, "j", VOID, window_set_level(N, a[0].i))
SV_GEN(irssi_ui_window, set_refnum, WINDOW_REC, "j", VOID, window_set_refnum(N, a[0].i))
SV_GEN(irssi_ui_window, view, WINDOW_REC, "", TOBJ(Irssi::TextUI::TextBufferView), WINDOW_GUI(N)->view)
SV_GEN(irssi_ui_window, items, WINDOW_REC, "", IOBJARR, N->items)
SV_GEN(irssi_ui_window, activity, WINDOW_REC, "j/S", VOID, window_activity(N, a[0].i, a[1].s))
SV_GEN(irssi_ui_window, last_line_insert, WINDOW_REC, "", TOBJ(Irssi::TextUI::Line), WINDOW_GUI(N)->insert_after)





SV_GEN(irssi_server, channel_find, SERVER_REC, "S", IOBJ, channel_find(N, a[0].s))
SV_GEN(irssi_server, channels, SERVER_REC, "", IOBJARR, N->channels)
SV_GEN(irssi_server, channels_join, SERVER_REC, "Sb", VOID, N->channels_join(N,  a[0].s, a[1].b))
SV_GEN(irssi_server, command, SERVER_REC, "S", VOID, irssi_script_command(a[0].s, N, NULL))
SV_GEN(irssi_server, disconnect, SERVER_REC, "", VOID, server_disconnect(N))
SV_GEN(irssi_server, get_nick_flags, SERVER_REC, "", STR, N->get_nick_flags(N))
SV_GEN(irssi_server, ignore_check, SERVER_REC, "SSSSj", BOOL, ignore_check(N, a[0].s, a[1].s, a[2].s, a[3].s, a[4].i))
SV_GEN(irssi_server, ischannel, SERVER_REC, "S", BOOL, N->ischannel(N, a[0].s))
SV_GEN(irssi_server, isnickflag, SERVER_REC, "S", BOOL, N->isnickflag(N, *a[0].s))
SV_GEN(irssi_server, masks_match, SERVER_REC, "SSS", BOOL, masks_match(N, a[0].s, a[1].s, a[2].s))
SV_GEN(irssi_server, mask_match, SERVER_REC, "SSSS", BOOL, mask_match(N, a[0].s, a[1].s, a[2].s, a[3].s))
SV_GEN(irssi_server, mask_match_address, SERVER_REC, "SSS", BOOL, mask_match_address(N, a[0].s, a[1].s, a[2].s))
SV_GEN(irssi_server, queries, SERVER_REC, "", IOBJARR, N->queries)
SV_GEN(irssi_server, query_find, SERVER_REC, "S", IOBJ, query_find(N, a[0].s))
SV_GEN(irssi_server, send_message, SERVER_REC, "SSj", VOID, N->send_message(N, a[0].s, a[1].s, a[2].i))
SV_GEN(irssi_server, window_find_closest, SERVER_REC, "Sj", TOBJ(Irssi::UI::Window), window_find_closest(N, a[0].s, a[1].i))
SV_GEN(irssi_server, window_find_item, SERVER_REC, "S", TOBJ(Irssi::UI::Window), window_find_item(N, a[0].s))
SV_GEN(irssi_server, window_item_find, SERVER_REC, "S", IOBJ, window_item_find(N, a[0].s))
SV_GEN(irssi_server, window_find_level, SERVER_REC, "j", TOBJ(Irssi::UI::Window), window_find_level(N, a[0].i))

SV_GEN(irssi_windowitem, activity, WI_ITEM_REC, "j/S", VOID, window_item_activity(N, a[0].i, a[1].s))
SV_GEN(irssi_windowitem, command, WI_ITEM_REC, "S", VOID, irssi_script_command(a[0].s, N->server, N))
SV_GEN(irssi_windowitem, is_active, WI_ITEM_REC, "", BOOL, window_item_is_active(N))
SV_GEN(irssi_windowitem, get_dcc, WI_ITEM_REC, "", TOBJ(siobject), item_get_dcc(N))
SV_GEN(irssi_windowitem, set_active, WI_ITEM_REC, "", VOID, window_item_set_active(window_item_window(N), N))
SV_GEN(irssi_windowitem, window, WI_ITEM_REC, "", TOBJ(Irssi::UI::Window), window_item_window(N))
SV_GEN(irssi_windowitem, window_create, WI_ITEM_REC, "b", TOBJ(Irssi::UI::Window), window_create(N, a[0].b))

SV_GEN(irssi_channel, destroy, CHANNEL_REC, "", VOID, channel_destroy(N))
SV_GEN(irssi_channel, nick_find, CHANNEL_REC, "S", IOBJ, nicklist_find(N, a[0].s))
SV_GEN(irssi_channel, nick_find_mask, CHANNEL_REC, "S", IOBJ, nicklist_find_mask(N, a[0].s))

SV_GEN(irssi_query, destroy, QUERY_REC, "", VOID, query_destroy(N))

SV_GEN(irssi_log, close, LOG_REC, "", VOID, log_close(N))
SV_GEN(irssi_log, item_add, LOG_REC, "jSS", VOID, log_item_add(N, a[0].i, a[1].s, a[2].s))
SV_GEN(irssi_log, item_find, LOG_REC, "jSS", TOBJ(Irssi::Logitem), log_item_find(N, a[0].i, a[1].s, a[2].s))
SV_GEN(irssi_log, start_logging, LOG_REC, "", VOID, log_start_logging(N))
SV_GEN(irssi_log, stop_logging, LOG_REC, "", VOID, log_stop_logging(N))
SV_GEN(irssi_log, update, LOG_REC, "", VOID, log_update(N))
SV_GEN(irssi_log, write_rec, LOG_REC, "Sj", VOID, log_write_rec(N, a[0].s, a[1].i))

SV_GEN(irssi_ui_textdest, print, TEXT_DEST_REC,  "S", VOID, printtext_dest(N, "%s", a[0].s))

SV_GEN(irssi_rawlog, close, RAWLOG_REC, "", VOID, rawlog_close(N))
SV_GEN(irssi_rawlog, destroy, RAWLOG_REC, "", VOID, rawlog_destroy(N))
SV_GEN(irssi_rawlog, get_lines, RAWLOG_REC, "", STRARR, N ->lines)
SV_GEN(irssi_rawlog, input, RAWLOG_REC, "S", VOID, rawlog_input(N, a[0].s))
SV_GEN(irssi_rawlog, open, RAWLOG_REC, "S", VOID, rawlog_open(N, a[0].s))
SV_GEN(irssi_rawlog, output, RAWLOG_REC, "S", VOID, rawlog_output(N, a[0].s))
SV_GEN(irssi_rawlog, redirect, RAWLOG_REC, "S", VOID, rawlog_redirect(N, a[0].s))
SV_GEN(irssi_rawlog, save, RAWLOG_REC, "S", VOID, rawlog_save(N, a[0].s))

SV_GEN(irssi_textui_line, next, LINE_REC, "", TOBJ(Irssi::TextUI::Line), N->next) /* Irssi::TextUI::Line $line */
SV_GEN(irssi_textui_line, prev, LINE_REC, "", TOBJ(Irssi::TextUI::Line), N->prev) /* Irssi::TextUI::Line $line */

SV_GEN(irssi_textui_textbufferview, clear, TEXT_BUFFER_VIEW_REC, "", VOID, textbuffer_view_clear(N))
SV_GEN(irssi_textui_textbufferview, get_bookmark, TEXT_BUFFER_VIEW_REC, "S", TOBJ(Irssi::TextUI::Line), textbuffer_view_get_bookmark(N, a[0].s))
SV_GEN(irssi_textui_textbufferview, get_lines, TEXT_BUFFER_VIEW_REC, "", TOBJ(Irssi::TextUI::Line), textbuffer_view_get_lines(N))
SV_GEN(irssi_textui_textbufferview, redraw, TEXT_BUFFER_VIEW_REC, "", VOID, textbuffer_view_redraw(N))
SV_GEN(irssi_textui_textbufferview, remove_all_lines, TEXT_BUFFER_VIEW_REC, "", VOID, textbuffer_view_remove_all_lines(N))
SV_GEN(irssi_textui_textbufferview, scroll, TEXT_BUFFER_VIEW_REC, "j", VOID, textbuffer_view_scroll(N, a[0].i))
SV_GEN(irssi_textui_textbufferview, set_bookmark_bottom, TEXT_BUFFER_VIEW_REC, "S", VOID, textbuffer_view_set_bookmark_bottom(N, a[0].s))
SV_GEN(irssi_textui_textbufferview, set_default_indent, TEXT_BUFFER_VIEW_REC, "jb", VOID, textbuffer_view_set_default_indent(N, a[0].i, a[1].b, NULL))
SV_GEN(irssi_textui_textbufferview, set_scroll, TEXT_BUFFER_VIEW_REC, "b", VOID, textbuffer_view_set_scroll(N, a[0].b))

SF_GEN(irssi_ui_processes, "", TOBJARR(Irssi::UI::Process), processes)
SF_GEN(irssi_term_refresh_freeze, "", VOID, term_refresh_freeze())
SF_GEN(irssi_term_refresh_thaw, "", VOID, term_refresh_thaw())
